# Working 09-08-2020
from pymodbus.client.sync import ModbusTcpClient
import plc_sensor_pump
import time
#import subprocess
#import os
#import socket

DEBUG=False
HOST="10.0.255.102"
client=None
LEVEL_MODIFICATION_TIME=.5
  
def scan():
    try:
        if DEBUG:
            debug_data = (read_data(1, 4))
            print("Power: " + str(debug_data[0]))
            print("Start: " + str(debug_data[1]))
            print("Stop : " + str(debug_data[2]))
            print("Pump : " + str(debug_data[3]))
            print("Reset : " + str(debug_data[4]))
        # Check power status only process if power is on
        if plc_sensor_pump.read_data(1, 1, client)[0]:
            tank_data = plc_sensor_pump.read_data(400001, 3, client)
            # Check pump status and add or remove water
            # once every LEVEL_MODIFICATION_TIME seconds
            global current_time
            if time.perf_counter() >= (current_time + LEVEL_MODIFICATION_TIME):
                if plc_sensor_pump.read_data(4,1,client)[0]:
                    tank_data[0] += 1
                else:
                    tank_data[0] -= 1                
                current_time = time.perf_counter()
            plc_sensor_pump.write_data(400001, tank_data[0],client)
    except:
        print("Connection to PLC broken")
        if not plc_sensor_pump.check_host(HOST, 1000, 1):
            exit("No PLC runnning")
        else:
            print("Restarting sensor/pump processing")
            initialize()
        
            
def initialize():
    global client
    global current_time
    client = ModbusTcpClient(HOST)
    # Set current_time
    current_time = time.perf_counter()
   
if not plc_sensor_pump.check_host(HOST, 1000,1):
    exit("No PLC runnning")
else:
    print("Starting sensor/pump processing")
initialize()
while True:
    scan()
